<?php
class Codeviewer_model extends CI_Model {

	function __construct(){
		$this->load->database();
	}

	function getCode($cid, $category, $subcategory, $example) {

		$this->db->from('Files');
		$this->db->join("Containers", "Containers.fileName = Files.fileName");
		$this->db->where("Containers.categoryName", $category);
		$this->db->where("Containers.subcategoryName", $subcategory);
		$this->db->where("Containers.exampleName", $example);
		$this->db->where("Containers.courseID", $cid);
		$this->db->not_like("Containers.fileName", $cid."/".$category."/".$subcategory."/".$example."/documentation");

		$query = $this->db->get();
		$output = "";
		foreach ($query->result() as $row) {
			$output .= '<div class="editorinfo">'.$row->codeLanguage.'&nbsp;&nbsp;&nbsp;&nbsp;'.$row->fileName.'</div>';
			$output .= '<div id="ace_'.str_replace(".", "", $row->fileName).'" class="ace">';
			$output .= $row->dataBlob;
			$output .= '</div>';

			$output .=  '<script type="text/javascript">
			var Range = require("ace/range").Range;
			var editor = ace.edit("ace_'.str_replace(".", "", $row->fileName).'");
			editor.setTheme("ace/theme/merbivore");
			editor.getSession().setMode("ace/mode/'.$row->codeLanguage.'");
			editor.setReadOnly(true);
			editor.setShowPrintMargin(false);
			editor.setDisplayIndentGuides(false);
			editor.setHighlightSelectedWord(true);
			lines = editor.getSession().getLength();
			$("#ace_'.str_replace(".", "", $row->fileName).'").height(Math.min(500,lines*16));
			aceeditors.push("ace_'.str_replace(".", "", $row->fileName).'");';

			/*
			for($i = 0; $i < count($interestingrows); $i++) {
			$output .= 'editor.getSession().addMarker(new Range('.$interestingrows[$i][0].', 0, '
				.$interestingrows[$i][1].', Number.POSITIVE_INFINITY), "interesting", "text",false);';
			}
			*/
			$output .= '</script>';

		}

		return $output;
	}

	function getDoc($cid, $category, $subcategory, $example){
		$this->db->select('dataBlob');
		$this->db->from('Files');
		$this->db->join("Containers", "Containers.fileName = Files.fileName");
		$this->db->where("Containers.categoryName", $category);
		$this->db->where("Containers.subcategoryName", $subcategory);
		$this->db->where("Containers.exampleName", $example);
		$this->db->where("Containers.courseID", $cid);
		$this->db->where("Containers.fileName", $cid."/".$category."/".$subcategory."/".$example."/"."documentation");

		$query = $this->db->get();
		$result = $query->result();
		return $result[0]->dataBlob;
	}

}
